version: "2.2"

networks:
  common:
    driver: bridge

services:
  mongodb:
    container_name: mongodb
    image: mongo:5.0.2
    networks:
      - common
    restart: always
    env_file:
      - grainlife-api/.env.development
    environment:
      - MONGO_INITDB_ROOT_USERNAME=$MONGODB_USER
      - MONGO_INITDB_ROOT_PASSWORD=$MONGODB_PASSWORD
      - MONGO_INITDB_DATABASE=$MONGODB_DATABASE
    ports:
      - $MONGODB_LOCAL_PORT:$MONGODB_DOCKER_PORT
    volumes:
      - db:/data/db
      - ./grainlife-api/init-mongo.sh:/docker-entrypoint-initdb.d/init-mongo.sh:ro

  api:
    container_name: api
    depends_on:
      - mongodb
    build:
      context: ./grainlife-api
      dockerfile: Dockerfile.development
    networks:
      - common
    restart: always
    env_file: grainlife-api/.env.development
    ports:
      - "5000:5000"
    volumes:
      - ./grainlife-api/:/app
      - ignore:/app/node_modules/
    stdin_open: true
    tty: true

  frontend:
    build:
      context: ./grainlife-frontend
      dockerfile: Dockerfile.development
    networks:
      - common
    container_name: frontend
    restart: always
    volumes:
      - ./grainlife-frontend/:/app
      - /app/node_modules
      - /app/.next
    ports:
      - "3000:3000"

  backend:
    networks:
      - common
    build:
      context: ./grainlife-backend
      dockerfile: Dockerfile.development
    container_name: backend
    restart: always
    volumes:
      - ./grainlife-backend/:/app
      - /app/node_modules
    ports:
      - "3001:3001"

  nginx:
    container_name: nginx
    networks:
      - common
    build:
      context: ./nginx
      dockerfile: Dockerfile
    ports:
      - "80:80"
    restart: always
    depends_on:
      - backend
      - frontend
      - api

volumes:
  db:
  ignore:
